//import store from '@/store'
import config from '../config.js'
import cacheManager from '@/utils/cacheManager.js'
import {
	Md5
} from 'ts-md5/dist/md5';
import errorCode from '@/utils/errorCode'
import {
	toast,
	showConfirm,
	tansParams
} from '@/utils/common'

let timeout = 10000
const baseUrl = config.baseUrl
const request = config => {

	// 是否需要设置 token
	// const isToken = (config.headers || {}).isToken === false
	config.header = config.header || {}


	//  if (getToken() && !isToken) {
	// config.headers['X-AUTH-SIGN'] = Md5.hashStr(JSON.stringify(config.data) +auth.secret);
	// config.headers['X-AUTH-TOKEN'] = auth.token;
	//  }
	if (cacheManager.get('auth')) {
		config.headers['X-AUTH-SIGN'] = Md5.hashStr(JSON.stringify(config.data) + cacheManager.get('auth').secret);
		config.headers['X-AUTH-TOKEN'] = cacheManager.get('auth').token;
	}
	return new Promise((resolve, reject) => {
		//  debugger
		uni.request({
				method: config.method || 'get',
				timeout: config.timeout || timeout,
				url: config.baseUrl || baseUrl + config.url,
				data: config.data,
				header: config.headers,
				dataType: 'json'
			}).then(response => {
				const res = response.data;
				// if (error) {
				//   toast('后端接口连接异常')
				//   reject('后端接口连接异常')
				//   return
				// }
				const code = res.code
				const msg = res.msg
				// const msg = errorCode[code] || res.data.msg || errorCode['default']
				if (code === 401) {
					showConfirm('登录状态已过期，您可以继续留在该页面，或者重新登录?').then(res => {
						if (res.confirm) {
							if (cacheManager.get('auth')) {
								cacheManager.clearAll()
							}
							uni.reLaunch({
								url: '/pages/login/index'
							})
						}
					})
					reject('无效的会话，或者会话已过期，请重新登录。')
				} else if (code === 405) {
					showConfirm('登录状态已过期，您可以继续留在该页面，或者重新登录?').then(res => {
						if (res.confirm) {
							if (cacheManager.get('auth')) {
								cacheManager.clearAll()
							}
							uni.reLaunch({
								url: '/pages/login/index'
							})
						}

					})
					reject('无效的会话，或者会话已过期，请重新登录。')
				} else if (code === 500) {
					toast("数据异常-500")
					reject('500')
				} else if (code === 400) {
					toast("数据异常-400")
					reject('400')
				} else if (code !== 0) {
					if (config.customCatch) {
						reject({
							code: code,
							data: res
						})
					} else {
						toast(msg)
						reject(code)
					}
				}
				resolve(res)
			})
			.catch(error => {
				console.log('error', error);
				let message = ''
				let {
					errMsg
				} = error
				console.log('error', error);
				if (errMsg.includes('timeout')) {
					message = '系统接口请求超时'
				} else {
					message = '网络连接异常，请检查网络后重试'
				}
				toast(message)
				reject(error)
			})
	})
}

export default request